﻿Imports Microsoft.Practices.Composite.Regions
Imports System.ComponentModel
Imports Telerik.Windows.Controls
Imports TabControlAndPrism.ViewModels

Namespace TabControlAndPrism
	Public Class ShellViewModel
		Implements INotifyPropertyChanged
		Private _regionmanager As IRegionManager
		Public Sub New(ByVal regionManager As IRegionManager)
			_regionmanager = regionManager
		End Sub

		Public Sub CreateViews()
			Dim reg As IRegion = _regionmanager.Regions("telRegion")
			Dim v As UserControl = New View1()
			v.DataContext = New ViewModel1() With {.DisplayName = "View1"}
			reg.Add(v, "view1")
			v = New View2()
			v.DataContext = New ViewModel2 With {.DisplayName = "View2"}
			reg.Add(v, "view2")
		End Sub

		Public Sub SelectView1()
			Dim reg As IRegion = _regionmanager.Regions("telRegion")
			Me.SelectedView = reg.GetView("view1")
			reg.Activate(Me.SelectedView)
		End Sub

		Private _selectedView As Object

		Public Property SelectedView() As Object
			Get
				Return Me._selectedView
			End Get
			Set(ByVal value As Object)
				If Me._selectedView IsNot value Then
					Me._selectedView = value
					Me.OnPropertyChanged("SelectedView")
				End If
			End Set
		End Property

		Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

		Private Overloads Sub OnPropertyChanged(ByVal propertyName As String)
			RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
		End Sub
	End Class
End Namespace
